<template>
    <v-card :color="color"  class="mx-auto mt-3" width="700" @mouseover="color='grey'" @mouseleave="color='white'">
        <v-container>
            <v-row align="center">
                <v-col cols="2">
                        <img width="100" style="cursor: pointer" :src="character.image" @click="openCharacter">
                </v-col>    
                <v-col>
                    <v-row> 
                        <h2 style="cursor: pointer" @click="openCharacter"> {{character.name}}
                        </h2>
                    </v-row>
                    <v-row> 
                        <v-col>
                            <span>Gender : </span><v-icon>{{getGender}}</v-icon>
                        </v-col>
                        <v-col>
                            <span>Status : <v-chip :color="getColor">{{character.status}}</v-chip></span>
                        </v-col>
                        <v-col>
                            <span>Specie : {{character.species}}</span>
                        </v-col>
                    </v-row>
                    <v-row>
                        <v-col>
                            <span>Origin : <v-chip style="cursor: pointer" @click="openOrigin">{{character.origin.name}}</v-chip></span>
                        </v-col>
                        <v-col>
                            <span>Location : <v-chip style="cursor: pointer" @click="openLocation">{{character.location.name}}</v-chip></span>
                        </v-col>
                    </v-row>
                    <v-row>
                        <span>Created at : {{getCreatedAt}}</span>
                    </v-row>
                </v-col>
                <v-col cols="1" style="cursor: pointer" @click="openCharacter">
                    <v-icon>mdi-eye</v-icon>
                </v-col>
            </v-row>
            <v-row>
                <v-expansion-panels>
                    <v-expansion-panel>
                        <v-expansion-panel-header>
                            Episodes
                        </v-expansion-panel-header>
                        <v-expansion-panel-content>
                        <v-container>
                            <v-row v-for="episode in character.episode" :key="episode">
                                <episode-character :episode="episode" ></episode-character>
                            </v-row>
                        </v-container>
                        </v-expansion-panel-content>
                    </v-expansion-panel>
            </v-expansion-panels>
            </v-row>
        </v-container>
    </v-card>
</template>
<script>
import moment from 'moment'
import EpisodeCharacter from './Elements/episodeCharacter.vue';

export default {
  components: {EpisodeCharacter  },
    props: {character: null},
    data: () => ({
        color: 'white',
  }),
  computed: {
      getColor(){
          if(this.character.status == "Alive"){
              return "green";
          }else if(this.character.status == "Dead"){
              return "red";
          }else{
              return "grey";
          }
      },
      getGender(){
          if(this.character.gender == "Male"){
              return 'mdi-gender-male';
          }else{
              return 'mdi-gender-female';
          }
      },
      getCreatedAt(){
          return moment(this.character.created).format("DD/MM/yyyy");
      }
  },
  methods: {
      openLocation(){
          this.$router.push({name: 'location',query: { id: this.character.location.url.replace('https://rickandmortyapi.com/api/location/', '') },});
      },
      openOrigin(){
          this.$router.push({name: 'location',query: { id: this.character.origin.url.replace('https://rickandmortyapi.com/api/location/', '') },});
        },
      openCharacter(){
          this.$router.push({name: 'characters',query: { id: this.character.id },});
      },
  }
    
}
</script>
<style>

</style>